;---8<------------------------[t_gen32.asm]--------------------------------8<--;
;                                                                              ;
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx;
;                             [TRASH GENERATOR V. 0.2]                         ;
;                                                                              ;
;	#############       #############   #############   ######    ####     ;
;	#############      ##############  ##############  ########   ####     ;
;	    ###            ###             ###             ###  ###   ####     ;
;	    ###            ###  ########   ##############  ###  ###   ####     ;
;	    ###            ###  #########  ##############  ###  ###   ###      ;
;	    ###            ###        ###  ###             ###  ###   ###      ;
;	    ###            ##############  ##############  ###  #########      ;
;	    ###  #########  ############    #############  ###   #######       ;
;	         #########                                                     ;
;                                                                              ;
;                                                                              ;
;                                  FOR MS WINDOWS                              ;
;                                                                              ;
;                                      BY SL0N                                 ;
;------------------------------------------------------------------------------;
;                                      MANUAL:                                 ;
;                                                                              ;
; LENGTH OF GARBAGE   -> ECX  			                               ;
; BUFFER FOR GARBAGE  -> EDI                    		               ;
; USELESS REGISTER N1 -> BH (0..7)               		               ;
; USELESS REGISTER N2 -> BL (0..7)                      		       ;
;						 			       ;
; CALL GARBAGE	                                                               ;
;------------------------------------------------------------------------------;
;                           IT GENERATES INSTRUCTIONS:                         ;
;                                                                              ;
; MOV, MOVSX/ZX, XCHG, LEA, ADD/ADC/AND/OR/SUB/SBB/XOR/CMP                     ;
; INC/DEC, NOT/NEG, TEST, IMUL, ROL/ROR/RCL/RCR/SHL/SHR                        ;
; SHLD/SHRD, XADD, BSR/BSF, BT/BTC/BTR/BTS, JMP,REPZ/NZ                        ;
; PUSH/POP, X87, JX/JNX, STX, CLX, NOP, SALC, RDTSC, CPUID,		       ;
; CALL, CMOVxx, VERW, ARPL                     				       ;
;                                                                              ;
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx;
garbage:                                           ;  
						   ;  
		push	edx                        ;   
		push	ecx                        ; edx, ecx, ebx, ebp, esi
		push	esi                        ; 
		push	ebp                        ;
		push	ebx                        ;

		call	delta_offset1              ; 
delta_offset1:	pop	ebp                        ;   
		sub	ebp,offset delta_offset1   ;
delta_offset:
		mov	eax,22                     ;   
		call	brandom32                  ;   
						   ; 
		shl	eax,1                      ;  eax  2
		lea	esi,[ebp+mega_table]       ;  esi   
						   ;  
		add	esi,eax                    ;  esi  eax
		xor	eax,eax                    ;  eax
		lodsw                              ;  ax  
						   ;   
						   ;  delta_offset
		lea	esi,[ebp+delta_offset]     ;  esi   
						   ;  delta_offset
		add	eax,esi                    ;   
						   ; 
		call	eax                        ;  
		jmp	delta_offset               ;   delta_offset
;------------------------------------------------------------------------------;
instr_je:
		mov	eax,50			   ;   
		call	brandom32                  ;   0..49
		push	eax                        ;    
		add	eax,2                      ;   
		cmp	eax,ecx                    ;    
		pop	eax                        ;   
		jle	gen1                       ;    
		ret                                ;    
gen1:                                              ;
		push	eax                        ;     
		mov	eax,10                     ;   
		call	brandom32                  ;   0..9
		add	al,70h                     ;  70h
		stosb                              ;     
		pop	eax                        ;    
		stosb                              ;   
                mov	edx,eax                    ;    edx
		push	ecx                        ;  ecx  
		mov	ecx,edx                    ;  
		call	garbage                    ;   
		pop	ecx                        ;  ecx
						   ;     
						   ;  ,
						   ; , 
						   ; :
						   ; ...................
						   ; je             $+10
						   ; jae	    $+2
						   ; ...................
		sub	ecx,2                      ;    2
		sub	ecx,edx                    ;    
		ret                                ;   
;------------------------------------------------------------------------------;
instr_not:
		cmp	cl,2                       ;   
		jl	one_byte                   ;   2, 
		                                   ;    
						   ;  
		mov	al,0f7h                    ;   al - 0f7h
		stosb                              ;     
		mov	dl,0d0h                    ;   dl - 0dh 
		mov	eax,2                      ;   
		call	brandom32                  ;   0..2
		shl	eax,3                      ;   8
		add	dl,al                      ;   dl - al
		call	free_reg                   ;   
		                                   ;   
						   ; 
		add	al,dl		           ;   al - dl
		stosb                              ;     
						   ;     
						   ;  
						   ;  NOT/NEG:
						   ; ...................
						   ; not             eax
						   ; neg	     edx
						   ; ...................
		sub	ecx,2                      ;    2
		ret                                ;   
;------------------------------------------------------------------------------;
instr_je2:
		mov	eax,50			   ;   
		call	brandom32                  ;   0..49
		push	eax                        ;    
		add	eax,6                      ;   
		cmp	eax,ecx                    ;    
		pop	eax                        ;   
		jle	gen2                       ;    
		ret                                ;    
gen2:                                              ;
		push	eax                        ;    eax
		mov	al,0fh                     ;   al - 0fh
		stosb                              ;     
		mov	eax,10                     ;   
		call	brandom32                  ;   0..9
		                                   ;
		add	al,80h                     ;  80h
		stosb                              ;     
		pop	eax                        ;    eax
		stosd                              ;    
                mov	edx,eax                    ;   edx - eax
		push	ecx                        ;  ecx  
		mov	ecx,edx                    ;  
		call	garbage                    ;   
		pop	ecx                        ;  ecx
       						   ;     
						   ;  ,
						   ; , 
						   ; :
						   ; ...................
						   ; je             $+7
						   ; jae	    $+13
						   ; ...................
		sub	ecx,6                      ;    6
		sub	ecx,edx                    ;    
		                                   ;
		ret                                ;   
;------------------------------------------------------------------------------;
instr_x87:
		cmp	cl,2                       ;   
		jl	one_byte                   ;   2, 
		                                   ;    
						   ;  
		mov	al,0dch                    ;   al - 0dch
		stosb                              ;   al  
		mov	eax,02fh                   ;   
		call	brandom32                  ;   0..2eh
		add	al,0c0h                    ;    0c0h
		stosb                              ;     
						   ;     
						   ;  
						   ;  :
						   ; ...................
						   ; fadd       st(0),st
						   ; fmul       st(7),st
						   ; ...................
		sub	ecx,2                      ;    2
		ret                                ;   
;------------------------------------------------------------------------------;
instr_cmp:
		cmp	cl,2                       ;   
		jl	one_byte                   ;   2, 
		                                   ;    
						   ;  
		mov	dl,3ah                     ;   dl - 03ah
		mov	eax,3                      ;   
		call	brandom32                  ;   0..2
		add	al,dl                      ;   al - dl
		stosb                              ;   al  
		call	rnd_reg                    ;   
		shl	eax,3                      ;  eax  8
		add	al,0c0h                    ;   al - 0c0h
		mov	dl,al                      ;   dl - al
		call	rnd_reg                    ;   
		add	al,dl                      ;   al - dl
		stosb                              ;   al  
						   ;     
						   ;  
						   ;  CMP:
						   ; ...................
						   ; cmp         eax,esp
						   ; cmp          al,0c0
						   ; ...................
		sub	ecx,2                      ;    2
		ret                                ;   
;------------------------------------------------------------------------------;
instr_xor:
		cmp	cl,2                       ;   
		jl	one_byte                   ;   2, 
		                                   ;    
						   ;  
		mov	al,33h                     ;   al - 33h
		stosb                              ;      
		call	free_reg                   ;   
		                                   ;   
						   ; 
		shl	eax,3                      ;  eax  8
		add	al,0c0h                    ;   al - 0c0h
		mov	dl,al                      ;   dl - al
		call	rnd_reg                    ;   
		add	al,dl                      ;   al - dl
		stosb                              ;   al  
						   ;     
						   ;  
						   ;  XOR:
						   ; ...................
						   ; xor         eax,esp
						   ; xor         edi,ecx
						   ; ...................
		sub	ecx,2                      ;    2
		ret                                ;   
;------------------------------------------------------------------------------;
instr_test:
		cmp	cl,2                       ;   
		jl	one_byte                   ;   2, 
		                                   ;    
						   ;  
		mov	dl,084h                    ;   dl - 084h
		mov	eax,2                      ;   
		call	brandom32                  ;   0..1
		add	al,dl                      ;   al - dl
		stosb                              ;      
		call	rnd_reg                    ;   
		                                   ;   
						   ; 
		add	al,0c0h                    ;   al - 0c0h
		mov	dl,al                      ;   dl - al
		call	rnd_reg                    ;   
		add	al,dl                      ;   al - dl
		stosb                              ;   al  
						   ;     
						   ;  
						   ;  XOR:
						   ; ...................
						   ; test        eax,esp
						   ; test          al,cl
						   ; ...................
		sub	ecx,2                      ;    2
		ret                                ;   
;------------------------------------------------------------------------------;
instr_movr:
		cmp	cl,2                       ;   
		jl	one_byte                   ;   2, 
		                                   ;    
						   ;  
		mov	al,8bh			   ;   al - 8bh
		stosb                              ;   al  
		call	free_reg                   ;   
		                                   ;   
						   ; 
		shl	eax,3                      ;  eax  8
		add	al,0c0h                    ;   al - 0c0h
		mov	dl,al                      ;   dl - al
		call	rnd_reg                    ;   
		add	al,dl                      ;   al - dl
		stosb                              ;   al  
						   ;     
						   ;  
						   ;  MOV:
						   ; ...................
						   ; mov         eax,esp
						   ; mov         edi,ecx
						   ; ...................
		sub	ecx,2                      ;    2
		ret                                ;   
;------------------------------------------------------------------------------;
instr_push:
		cmp	cl,2                       ;   
		jl	one_byte                   ;   2, 
		                                   ;    
						   ;  
		call	rnd_reg                    ;   
		add	al,50h                     ;   al - 50h
		stosb                              ;  al  
		call	free_reg                   ;   
		                                   ;   
						   ; 
		add	al,58h                     ;   al - 8
		stosb                              ;    al  
						   ;     
						   ;  
						   ;  PUSH/POP:
						   ; ...................
						   ; push            eax
						   ; pop             ecx
						   ; ...................
		sub	ecx,2                      ;    2
		ret                                ;   
;------------------------------------------------------------------------------;
instr_movc:
		cmp	cl,5                       ;   
		jge	g1__                       ;   5, 
		ret                                ;
g1__:						   ; 
		call	free_reg                   ;   
		                                   ;   
						   ; 
		add	al,0b8h                    ;   al - 0b8h
		stosb                              ;   al  
		call	random32                   ;  
		stosd                              ; 
						   ;     
						   ;  
						   ;  MOV:
						   ; ...................
						   ; mov    eax,12345678
						   ; mov    ebp,00056800
						   ; ...................
		sub	ecx,5                      ;    5
		ret                                ;   
;------------------------------------------------------------------------------;
instr_jmp:
		mov	eax,50			   ;   
		call	brandom32                  ;   0..19
		push	eax                        ;    
		add	eax,5                      ;   
		cmp	eax,ecx                    ;    
		pop	eax                        ;   
		jle	gen3                       ;    
		ret                                ;    
gen3:                                              ;
		push	eax                        ;    eax
		mov	al,0e9h                    ;   al - 0b8h
		stosb                              ;   al  
		pop	eax                        ;   
		stosd                              ;    
                mov	edx,eax                    ;   edx - eax
		push	ecx                        ;  ecx  
		mov	ecx,edx                    ;  
		call	garbage                    ;   
		pop	ecx                        ;  ecx
						   ;     
						   ;  
						   ;  JMP:
						   ; ...................
						   ; jmp             $+5
						   ; ...................
		sub	ecx,5                      ;    6
		sub	ecx,edx                    ;    
		                                   ;
		ret                                ;   
;------------------------------------------------------------------------------;
instr_l32:
		cmp	cl,6                       ;   
		jge	g2__                       ;   6, 
		ret                                ;  
g2__:
		mov	al,81h                     ;   al - 81h
		stosb                              ;   al  
		mov	eax,4                      ;   
		call	brandom32                  ;    0..9
		add	al,0ch                     ;    - 0ch
		mov	dl,10h                     ;   dl - 10h
		mul	dl                         ;   dl
		mov	dl,al                      ;   dl - al
		mov	eax,2                      ;   
		call	brandom32                  ;    0..1
		shl	al,3                       ;  al  8
		add	dl,al                      ;   dl - al
		call	free_reg                   ;   
		                                   ;   
						   ; 
		add	al,dl                      ;   al - dl
		stosb                              ;   al  
		call	random32                   ;  
		stosd                              ;      
						   ;     
						   ;  
						   ;  ADD:
						   ; ...................
						   ; add    eax,12345678
						   ; or     ebp,00056800
						   ; ...................
		sub	ecx,6                      ;    5
		ret                                ;   
;------------------------------------------------------------------------------;
instr_lea:
		cmp	cl,6                       ;   
		jge	g3__                       ;   6, 
		ret                                ;  
g3__:
		mov	al,8dh                     ;   al - 8dh
		stosb                              ;   al  
		mov	dl,08h                     ;   dl - 08h
		call	free_reg                   ;   
		                                   ;   
						   ; 
		mul	dl                         ;   al - dl
		add	al,5			   ;   al - 5
		stosb                              ;   al  
		call	random32                   ;  
		stosd                              ; 
						   ;     
						   ;  
						   ;  LEA:
						   ; ...................
						   ; lea  eax,[12345678]
						   ; lea  ebp,[00056800]
						   ; ...................
		sub	ecx,6                      ;    6
		ret                                ;   
;------------------------------------------------------------------------------;
instr_cl:
		mov	eax,40                     ;   
		call	brandom32                  ;   0..39
		mov	edx,eax                    ;     edx

		mov	eax,40			   ;   
		call	brandom32                  ;   0..49
		push	eax                        ;    
		add	eax,11                     ;   
		add	eax,edx
		cmp	eax,ecx                    ;    
		pop	eax                        ;   
		jle	gen4                       ;    
		ret                                ;    
gen4:                                              
		push	edx                        ;
		push	eax                        ;    eax
		mov	al,0e8h                    ;   al - e8h
		stosb                              ;   al  
		mov	eax,[esp]                  ;
		inc	eax                        ;
		stosd                              ;   
		mov	eax,-1                     ;
		call	brandom32                  ;    
		stosb                              ; 
		pop	edx                        ;     edx
		push	ecx                        ;  ecx  
		mov	ecx,edx                    ;  
		call	garbage                    ;   
		pop	ecx                        ;  ecx

		mov	al,55h                     ;    055h
		stosb                              ;
		mov	ax,0ec8bh                  ;    0ec8bh
		stosw                              ;

		push	edx                        ;  edx  

		mov	edx,dword ptr [esp+4]      ;     edx
		push	ecx                        ;  ecx  
		mov	ecx,edx                    ;  
		call	garbage                    ;   
		pop	ecx                        ;  ecx

		mov	al,5dh                     ;    05dh
		stosb                              ; 

		call	free_reg                   ;   
		                                   ;   
						   ; 
		add	al,58h                     ;   al - 58
		stosb                              ;    al  
						   ;     
						   ;  
						   ;  CALL:
						   ; ...................
						   ; call            $+5
						   ; db		     xx
						   ; pop             eax
						   ; ...................
		sub	ecx,11                     ;    11
		pop	edx
		sub	ecx,edx                    ;    
		pop	edx                        ;
		sub	ecx,edx                    ;
		                                   ;
		ret                                ;   
;------------------------------------------------------------------------------;
instr_shl:
		cmp	cl,3                       ;   
		jge	g4__                       ;   3, 
		ret                                ;  
g4__:
		mov	al,0c1h                    ;   al - 0c1h
		stosb                              ;   al  
		mov	eax,6                      ;   
		call	brandom32                  ;   0..5
		shl	eax,3                      ;    8
		add	al,0c0h                    ;    - 0c0h
		mov	dl,al                      ;   dl - al
		call	free_reg                   ;   
		                                   ;   
						   ; 
		add	al,dl                      ;   al - dl
		stosb                              ;   al  
		mov	eax,256                    ;   
		call	brandom32                  ;   0..255
		stosb		                   ;     
						   ;     
						   ;  
						   ;  SHL,ROL, ...:
						   ; ...................
						   ; ror          eax,78
						   ; shl          ebp,04
						   ; ...................
		sub	ecx,3                      ;    3
		ret                                ;   
;------------------------------------------------------------------------------;
instr_a32:
		cmp	cl,3                       ;   
		jge	g5__                       ;   6, 
		ret                                ;  
g5__:
		mov	al,0fh                     ;   al - 0fh
		stosb                              ;   al  
		lea	esi,[ebp+three_byte_opcode];   esi  
						   ;   3- 
						   ; 
		mov	eax,14                     ;   
		call	brandom32                  ;   0..13
		add	esi,eax                    ;   esi - eax 
		movsb                              ;    
		mov	dl,0c0h                    ;   dl - 00h
		call	free_reg                   ;   
		                                   ;   
						   ; 
		shl	eax,3			   ;  eax  8
		add	dl,al                      ;   dl - al
		call	free_reg                   ;   
		                                   ;   
						   ; 
		add	al,dl                      ;   al - dl
		stosb                              ;   al  
						   ;     
						   ;  
						   ;  XADD,IMUL, ...:
						   ; ...................
						   ; xadd        eax,eax
						   ; imul        ebp,ecx
						   ; ...................
		sub	ecx,3                      ;    3
		ret                                ;   
;------------------------------------------------------------------------------;
instr_xchg:
		cmp	cl,2                       ;   
		jl	one_byte                   ;   2, 
		                                   ;    
						   ;  
		mov	al,087h                    ;   al - 087h
		stosb                              ;   al  
		mov	dl,0c0h                    ;   dl - 00h
		call	free_reg                   ;   
		                                   ;   
						   ; 
		shl	eax,3			   ;  eax  8
		add	dl,al                      ;   dl - al
		call	free_reg                   ;   
		                                   ;   
						   ; 
		add	al,dl                      ;   al - dl
		stosb                              ;   al  
						   ;     
						   ;  
						   ;  XCHG:
						   ; ...................
						   ; xchg        eax,eax
						   ; xchg        ebp,ecx
						   ; ...................
		sub	ecx,2                      ;    2
		ret                                ;   
;------------------------------------------------------------------------------;
instr_a16:
		cmp	cl,4                       ;   
		jge	g6__                       ;   4, 
		ret                                ;  
g6__:

		mov	al,066h                    ;   al - 066h
		stosb                              ;   al  
		mov	dl,0b8h                    ;   dl - 0b8h
		call	free_reg                   ;   
		                                   ;   
						   ; 
		add	al,dl                      ;   al - dl
		stosb                              ;   al  
		mov	eax,0ffffh                 ;   
		call	brandom32                  ;   0..65534
		stosw                              ;     
						   ;     
						   ;  
						   ;  MOV:
						   ; ...................
						   ; mov         ax,3452
						   ; mov         bp,1234
						   ; ...................
		sub	ecx,4                      ;    4
		ret                                ;   
;------------------------------------------------------------------------------;
instr_arp:
		cmp	cl,2                       ;   
		jl	one_byte                   ;   2, 
		                                   ;    
						   ;  
		mov	al,63h			   ;   al - 63h
		stosb                              ;   al  
		call	free_reg                   ;   
		                                   ;   
						   ; 
		shl	eax,3                      ;  eax  8
		add	al,0c0h                    ;   al - 0c0h
		mov	dl,al                      ;   cl - al
		call	free_reg                   ;   
		add	al,dl                      ;   al - cl
		stosb                              ;   al  
						   ;     
						   ;  
						   ;  MOV:
						   ; ...................
						   ; arpl        eax,esp
						   ; arpl        edi,ecx
						   ; ...................
		sub	ecx,2                      ;    2
		ret                                ;   
;------------------------------------------------------------------------------;
instr_cma:
		cmp	cl,3                       ;   
		jge	g7__                       ;   6, 
		ret                                ;  
g7__:
		mov	al,0fh                     ;   al - 0c1h
		stosb                              ;   al  
		mov	eax,15                     ;   
		call	brandom32                  ;   0..14
		add	al,40h                     ;   al - 40h
		stosb                              ;   al  
		call	free_reg                   ;   
		shl	eax,3                      ;    8
		add	al,0c0h                    ;    - 0c0h
		mov	dl,al                      ;   dl - al
		call	rnd_reg                    ;   
		                                   ;   
						   ; 
		add	al,dl                      ;   al - dl
		stosb                              ;   al  
						   ;     
						   ;  
						   ;  SHL,ROL, ...:
						   ; ...................
						   ; cmova        eax,edx
						   ; cmove        ebp,ecx
						   ; ...................
		sub	ecx,3                      ;    3
		ret                                ;   
;------------------------------------------------------------------------------;
instr_ver:
		cmp	cl,3                       ;   
		jge	g8__                       ;   3, 
		ret                                ;  
g8__:
		mov	ax,000fh                   ;   ax - 000fh
		stosw                              ;   ax  
		call	free_reg                   ;   
		add	al,0e8h                    ;    - 0e8h
		stosb                              ;   al  
						   ;     
						   ;  
						   ;  VERW:
						   ; ...................
						   ; verw             ax
						   ; verw             cx
						   ; ...................
		sub	ecx,3                      ;    3
		ret                                ;   
;------------------------------------------------------------------------------;
one_byte:
		mov	eax,3                      ;   
		call	brandom32                  ;   0..2
		                                   
		cmp	al,1                       ;   = 1,  
		je	instr_inc                  ;   INC

		cmp	al,2                       ;   = 2, 
		je	instr_dec                  ;   DEC

		lea	esi,[ebp+one_byte_opcode]  ;   esi  
						   ;  
						   ; 
		mov	eax,8                      ;   
		call	brandom32                  ;   0..7
		add	esi,eax                    ;   esi - eax 
		test	ecx,ecx                    ;    = 0,
		jz	landing                    ;    
		movsb                              ;  
						   ;    
						   ;     
						   ;  
						   ;   :
						   ; ...................
						   ; cld             
						   ; nop             
						   ; ...................
		dec	ecx                        ;  ecx  
		ret                                ;   
;------------------------------------------------------------------------------;
instr_inc:
		call	free_reg                   ;   
		                                   ;   
						   ; 
		add	al,40h                     ;   al - 40h
		test	ecx,ecx                    ;    = 0,
		jz	landing                    ;    
		stosb                              ;  al  
						   ;     
						   ;  
						   ;  INC:
						   ; ...................
						   ; inc             eax
						   ; inc             ebp
						   ; ...................
		dec	ecx                        ;  ecx  
		ret                                ;   
;------------------------------------------------------------------------------;
instr_dec:
		call	free_reg                   ;   
		                                   ;   
						   ; 
		add	al,48h                     ;   al - 40h
		test	ecx,ecx                    ;    = 0,
		jz	landing                    ;    
		stosb                              ;  al  
						   ;     
						   ;  
						   ;  DEC:
						   ; ...................
						   ; dec             eax
						   ; dec             ebp
						   ; ...................
		dec	ecx                        ;  ecx  
		ret                                ;   
;------------------------------------------------------------------------------;
landing:        
		add	esp,4                      ;    
		pop	ebx                        ;    
		pop	ebp			   ; 
		pop	esi                        ;  
		pop	ecx                        ;  .
		pop	edx                        ;
		ret                                ;   
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx;
;			    FREE REGISTER SUBROUTINE		               ;
;------------------------------------------------------------------------------;
;			             [ IN ]				       ;
;                                                                              ;
;          		     NO INPUT IN SUBROTINE                             ;
;------------------------------------------------------------------------------;
;			             [ OUT ]				       ;
;									       ;
;               	     FREE REGISTER -> EAX                              ;
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx;
free_reg:                                          
						   ;  
                                                   ;  

		push	edx ecx                    ;    edx, ecx
another:                                           ;
		call	rnd_reg                    ;   
		cmp	al,bh	                   ;    
		je	another                    ;    reg1
		cmp	al,bl                      ;    
		je	another                    ;    reg1
		cmp	al,00000100b               ;    
		je	another                    ;  esp

		pop	ecx edx                    ;  ecx, edx
		ret                                ;   
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx;
;			    RANDOM REGISTER SUBROUTINE		               ;
;------------------------------------------------------------------------------;
;			             [ IN ]				       ;
;                                                                              ;
;          		     NO INPUT IN SUBROTINE                             ;
;------------------------------------------------------------------------------;
;			             [ OUT ]				       ;
;									       ;
;               	     RANDOM REGISTER -> EAX                            ;
;xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx;
rnd_reg:                                           
                                                   ;  
					           ;  

		mov	eax,8                      ;   
		call	brandom32                  ;   0..7
		ret                                ;   
;------------------------------------------------------------------------------;
mega_table:
		dw	instr_x87  -delta_offset   ;
		dw	instr_movr -delta_offset   ; 
		dw	instr_push -delta_offset   ; 
		dw	instr_shl  -delta_offset   ; 
		dw	instr_cmp  -delta_offset   ;
		dw	instr_xor  -delta_offset   ;
		dw	one_byte   -delta_offset   ;
		dw	instr_movc -delta_offset   ;
		dw	instr_je   -delta_offset   ;  
		dw	instr_je2  -delta_offset   ;    
		dw	instr_l32  -delta_offset   ; delta_offset
		dw	instr_jmp  -delta_offset   ;
		dw	instr_lea  -delta_offset   ;
		dw	instr_test -delta_offset   ;
		dw	instr_not  -delta_offset   ;
		dw	instr_xchg -delta_offset   ;
		dw	instr_a32  -delta_offset   ;
		dw	instr_arp  -delta_offset   ; 
		dw	instr_a16  -delta_offset   ;
		dw	instr_cma  -delta_offset   ; 
		dw	instr_cl   -delta_offset   ;
		dw	instr_ver  -delta_offset   ; 

;------------------------------------------------------------------------------;
one_byte_opcode:
		std                                ;
		cld                                ;  
		nop                                ; 
		clc                                ;
		stc                                ;
		cmc                                ;
		db	0f2h                       ; rep
		db	0f3h                       ; repnz
;------------------------------------------------------------------------------;
three_byte_opcode:
db		0a3h,0abh,0adh,0b3h,0bbh,0bdh,0bfh ;  
db		0b6h,0b7h,0beh,0afh,0bch,0c1h,0bdh ; 
;---8<------------------------[t_gen32.asm]--------------------------------8<--;
